include:
  remote: https://gitlab.com/pantacor/ci/container-ci/raw/master/yml/build-dockerfile.yml

variables:
  CONTAINER_IMAGE: registry.gitlab.com/$CI_PROJECT_PATH
  DOCKER_DRIVER: overlay2
  GIT_SUBMODULE_STRATEGY: recursive
  DOCKERFILE_PREFIX: ""
  PH_BASE_URL: "https://pvr.pantahub.com"
  API_BASE_URL: "https://api.pantahub.com"

.push-container:
  stage: deploy
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
    - wget https://gitlab.com/pantacor/pvr/-/jobs/artifacts/develop/download?job=build -O binaries.zip
    - unzip binaries.zip
    - tar -xf pvr.linux.amd64.tar.gz && mv pvr /usr/bin
    - apk update; apk add gettext squashfs-tools curl jq
  script:
    - |
      tmp="/tmp/${PLATFORM_NAME}_device_$target"
      echo "Cloning target device $PH_BASE_URL/$PHUSER/$PH_SCHEDULED_DEVICE"
      rm -rf $tmp || true
      token=$(curl --header "Content-Type: application/json" -X POST $API_BASE_URL/auth/login --data "{\"username\": \"$PHUSER\", \"password\": \"$PHPASS\"}" | jq -r .token)
      pvr -a $token clone --objects .pvr/objects $PH_BASE_URL/$PHUSER/$PH_SCHEDULED_DEVICE $tmp
      cd $tmp
      echo "Updating ${COMPONENT_NAME}"
      pvr app update ${COMPONENT_NAME}
      pvr app install ${COMPONENT_NAME}
      if ! [ "$PV_X5C_BUNDLE" == "" ]; then
        echo $PV_X5C_BUNDLE | base64 -d > /tmp/x5c.bundle
      fi
      if ! [ "$PV_SIGN_KEY" == "" ];
        then echo $PV_SIGN_KEY | base64 -d > /tmp/sign.key
      fi
      if ! [ "$PV_CA_TRUSTDB" == "" ]; then
        echo $PV_CA_TRUSTDB | base64 -d > /tmp/trustdb.pem
      fi
      if [ -f /tmp/x5c.bundle ] && [ -f /tmp/sign.key ] && [ -f /tmp/trustdb.pem ]; then 
        echo "Signing Platform ${COMPONENT_NAME} ..."  
        pvr sig --x5c /tmp/x5c.bundle --key /tmp/sign.key add --part ${COMPONENT_NAME}
        echo "Validating Signature for Platform ${COMPONENT_NAME} ..."
        pvr sig --cacerts /tmp/trustdb.pem ls ${COMPONENT_NAME}
      fi
      pvr add .
      pvr commit
      echo "Posting bsp to $PH_BASE_URL/$PHUSER/$PH_SCHEDULED_DEVICE"
      pvr -a $token post -m "auto commit from job $CI_PIPELINE_ID" $PH_BASE_URL/$PHUSER/$PH_SCHEDULED_DEVICE

